procedure send_simpleheader(var ss:send_struct;i:integer;st:string;len:integer);
begin
{$ifdef mod_config}
 ss.errorcode:=i;
 ss.contentlen:=len;
 write_alog(ss);
{$endif}
 if len>=0 then begin
  st:=st+#13#10'Content-length: '+strl(len);
 end;
 send_bstring(ss,'HTTP/1.0 '+strl(i)+' X'#13#10'Content-Type: '+st+#13#10#13#10);
end;

procedure redirect(var ss:send_struct;target:ansistring);
begin
{$ifdef mod_config}
 ss.errorcode:=302;
 ss.contentlen:=-1;
 write_alog(ss);
{$endif}
 if length(target)>0 then begin
  if target[1]='/' then target:='http://'+getheader(ss,'host')+target;
 end;
 if length(ss.qs)>0 then begin
  target:=target+'?'+ss.qs;
 end;
 send_bstring(ss,'HTTP/1.0 302 X'#13#10'Content-Type: text/html'#13#10'Location: '+target+#13#10#13#10'Moved to <a href="'+target+'">'+target+'</a>');
end;

{$ifdef mod_config}

procedure handle_send(var ss:send_struct;const fname:ansistring{$ifdef mod_config};n_mode:integer{$endif});
forward;


function send_custom_error(var ss:send_struct;page:ansistring;err:integer):boolean;
begin
 result:=false;
 if length(page)=0 then exit;
 ss.errorpage:=true;
 handle_send(ss,page,-err);
{ redirect(ss,page);}
 result:=true;
end;

{$endif}

procedure send_error2(var ss:send_struct;i:integer;ti,st,head:ansistring);
var
 q:string;
{$ifdef mod_config}
 ep:perrorpage;
{$endif}
begin
{$ifdef mod_config}
 write_elog(ss,'HTTP error '+strl(i)+' '+ti+' - '+st);
 if ss.config=nil then ss.config:=gcfg.defcfg;
 ep:=pconfig(ss.config)^.error;
 if ss.errorpage or ss.proxy then ep:=nil;
 while ep<>nil do begin
  if ep^.code=i then begin
   if send_custom_error(ss,ep^.page,i) then exit else break;{nenalezena errorpage, pouzije se defaultni}
  end;
  ep:=ep^.next;
 end;
{$endif}
 q:='<html><head><title>'+ti+'</title></head><body bgcolor=#ffffff text=#000000><h1 align=center><font color=#800000>Error '+strl(i)+' -  '+ti+'</font></h1><p>'+st+'</p></body></html>';
 send_simpleheader(ss,i,'text/html'+head,length(q));
 send_bstring(ss,q);
end;

procedure send_error(var ss:send_struct;i:integer;ti,st:ansistring);
begin
 send_error2(ss,i,ti,st,'');
end;

function getmimetype(ex:ansistring):ansistring;forward;

function getmimefromfile({$ifdef mod_conf}var ss:send_struct;{$endif}const s:ansistring):ansistring;
begin
{$ifdef mod_conf}
 if not(ss.privileged) and (ss.adef<>nil) then begin
  if length(pactdef(ss.adef)^.mime)>0 then begin
   getmimefromfile:=pactdef(ss.adef)^.mime;
   exit;
  end;
 end;
{$endif}
 getmimefromfile:=getmimetype(getextension(s));
end;
